package de.tudresden.inf.st.sample.callback;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import de.tudresden.inf.st.pnml.engine.execution.TransitionCallback;
import de.tudresden.inf.st.pnml.jastadd.model.BalloonToken;
import de.tudresden.inf.st.sample.balloon.Token;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

// only the token class is generated, this is a static class
// this class gets extended by the user for concrete callbacks
// this class hides (de-)serialisation of the tokens
public abstract class AbstractHandler extends TransitionCallback {

    public AbstractHandler(String id, int priority, List<String> params) {
        super(id, priority, params);
    }

    public AbstractHandler(String id, int priority) {
        super(id, priority);
    }

    private Token parseToken(String s) throws IOException {
        ObjectMapper mapper = new ObjectMapper();
        return mapper.readValue(s, Token.class);
    }

    public abstract void processTokenCallback(List<Token> tokens);

    @Override
    public final List<BalloonToken> processToken(List<BalloonToken> tokens) {

        List<Token> resultTokens = new ArrayList<>();
        List<BalloonToken> resultBalloonTokens = new ArrayList<>();
        ObjectMapper mapper = new ObjectMapper();

        for(BalloonToken bt : tokens){
            try {
                Token t = parseToken(bt.getValue());
                resultTokens.add(t);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        processTokenCallback(resultTokens);

        for(Token t : resultTokens){
            BalloonToken newBt = new BalloonToken();
            try {
                newBt.setValue(mapper.writerWithDefaultPrettyPrinter().writeValueAsString(t));
                resultBalloonTokens.add(newBt);
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }
        }

        return resultBalloonTokens;
    }
}
