package de.tudresden.inf.st.sample.callback;

import de.tudresden.inf.st.sample.balloon.Token;

import java.util.List;

public class FeedbackHandler extends AbstractHandler {

    public FeedbackHandler(String id, int priority) {
        super(id, priority);
    }

    void print(String line) {
        System.out.println(line);
    }

    @Override
    public void processTokenCallback(List<Token> tokens) {

        Token result = tokens.get(0);
        String color = result.getColor();
        String object = result.getObject();

        if (result.isPickPlaceSuccess()) {
            print("Successfully sorted object " + object + " with color " + color);
        } else {
            print("Failed to sort object " + object);
            result.getErrorList().forEach(this::print);
        }

        tokens.subList(1, tokens.size()).clear();
    }
}
