package de.tudresden.inf.st.sample.communication;

import de.tudresden.inf.st.pnml.engine.ros.DiNeRosNodeUtil;
import de.tudresden.inf.st.pnml.engine.ros.DiNeRosServer;
import de.tudresden.inf.st.pnml.jastadd.model.BalloonCallbackStorage;
import de.tudresden.inf.st.pnml.jastadd.model.BalloonMarking;
import de.tudresden.inf.st.pnml.jastadd.model.PetriNet;

public abstract class AbstractDinerosServer implements DiNeRosServer {

    @Override
    public final boolean execute(BalloonMarking balloonMarking, BalloonCallbackStorage balloonCallbackStorage, PetriNet petriNet, String s) {

        boolean success = false;

        // this mechanism enforces the user to leave a server instance with a clean state (see server def)
        while (DiNeRosNodeUtil.hasEnabledTransition(petriNet, s, balloonMarking)) {
            success = serve(balloonMarking, balloonCallbackStorage, petriNet, s);
        }

        return success;
    }

    public abstract boolean serve(BalloonMarking balloonMarking, BalloonCallbackStorage balloonCallbackStorage, PetriNet petriNet, String subnet);
}
