package de.tudresden.inf.st.sample.communication;

import de.tudresden.inf.st.pnml.engine.ros.DiNeRosNodeUtil;
import de.tudresden.inf.st.pnml.engine.ros.DiNeRosSubscriber;
import de.tudresden.inf.st.pnml.jastadd.model.BalloonCallbackStorage;
import de.tudresden.inf.st.pnml.jastadd.model.BalloonMarking;
import de.tudresden.inf.st.pnml.jastadd.model.PetriNet;

public abstract class AbstractDinerosSubscriber implements DiNeRosSubscriber {

    public final boolean execute(BalloonMarking balloonMarking, BalloonCallbackStorage balloonCallbackStorage, PetriNet petriNet, String subnet) {

        boolean success = false;

        // this mechanism enforces the user to leave a server instance with a clean state (see server def)
        while (DiNeRosNodeUtil.hasEnabledTransition(petriNet, subnet, balloonMarking)) {
            success = subscribe(balloonMarking, balloonCallbackStorage, petriNet, subnet);
        }

        return  success;
    }

    public abstract boolean subscribe(BalloonMarking balloonMarking, BalloonCallbackStorage balloonCallbackStorage, PetriNet petriNet, String subnet);
}
